/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"

enum{
    USB_DATA_LENGTH = 64,
    U16_BUFFER_SIZE = 16384,//tou com 2^14;  parece que é demasiado grande: 32767, //objetivo: 2^15 ou 2^16 ; antigo -> 1024
    U8_BUFFER_SIZE  = 2*U16_BUFFER_SIZE,
};

union Data{
    uint16_t u16_buffer[U16_BUFFER_SIZE];
    uint8_t u8_buffer[U8_BUFFER_SIZE];
};

/* Defines for DMA */
#define DMA_BYTES_PER_BURST 2
#define DMA_REQUEST_PER_BURST 1
#define DMA_SRC_BASE (CYDEV_PERIPH_BASE)
#define DMA_DST_BASE (CYDEV_SRAM_BASE)

/* Variable declarations for DMA */
/* Move these variable declarations to the top of the function */
uint8 DMA_Chan;
uint8 DMA_TD[4];

uint8 stop_flag = 0;


CY_ISR(DMA_done_flag){

    stop_flag = 1;  
}

int main(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */

    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
    DAC_Start();
    
    ADC_Start();
    DMA_DONE_INT_StartEx(DMA_done_flag);
    ADC_IRQ_Disable();   /* The ADC Interrupt is disabled because the system doesn't need the interrupt */
    ADC_StartConvert();  /* Start ADC conversion */
    
    union Data samples;
   
    /* DMA Configuration for DMA */
    DMA_Chan = DMA_DmaInitialize(DMA_BYTES_PER_BURST, DMA_REQUEST_PER_BURST, 
        HI16(DMA_SRC_BASE), HI16(DMA_DST_BASE));
    DMA_TD[0] = CyDmaTdAllocate();
    DMA_TD[1] = CyDmaTdAllocate();
    DMA_TD[2] = CyDmaTdAllocate();
    DMA_TD[3] = CyDmaTdAllocate();
    CyDmaTdSetConfiguration(DMA_TD[0], 4095, DMA_TD[1], CY_DMA_TD_INC_DST_ADR | CY_DMA_TD_AUTO_EXEC_NEXT);
    CyDmaTdSetConfiguration(DMA_TD[1], 4095, DMA_TD[2], CY_DMA_TD_INC_DST_ADR | CY_DMA_TD_AUTO_EXEC_NEXT);
    CyDmaTdSetConfiguration(DMA_TD[2], 4095, DMA_TD[3], CY_DMA_TD_INC_DST_ADR | CY_DMA_TD_AUTO_EXEC_NEXT);
    CyDmaTdSetConfiguration(DMA_TD[3], 4095, CY_DMA_DISABLE_TD, DMA__TD_TERMOUT_EN | CY_DMA_TD_INC_DST_ADR);
    CyDmaTdSetAddress(DMA_TD[0], LO16((uint32)ADC_DEC_SAMP_PTR), LO16((uint32)samples.u16_buffer[0]));
    CyDmaTdSetAddress(DMA_TD[1], LO16((uint32)ADC_DEC_SAMP_PTR), LO16((uint32)samples.u16_buffer[4096]));
    CyDmaTdSetAddress(DMA_TD[2], LO16((uint32)ADC_DEC_SAMP_PTR), LO16((uint32)samples.u16_buffer[8192]));
    CyDmaTdSetAddress(DMA_TD[3], LO16((uint32)ADC_DEC_SAMP_PTR), LO16((uint32)samples.u16_buffer[12288]));
    CyDmaChSetInitialTd(DMA_Chan, DMA_TD[0]);
    CyDmaChEnable(DMA_Chan, 1);

    for(;;)
    {
        /* Place your application code here. */
        if(stop_flag){
            LED_Write(1);
            //ADC_StopConvert();
            //CyDmaChDisable(DMA_Chan);
            stop_flag = 0;
        }
        
    }
}

/* [] END OF FILE */
